var globalShortcut = require('global-shortcut');
var KeyShortcuts = (function () {
    function KeyShortcuts(browser_window, config) {
        var _this = this;
        var sender = browser_window.webContents;
        var shortcuts = config.shortcuts;
        this.shortcuts = {};
        var key_receiver_for = function (s) {
            return function () {
                sender.send('keyinput', s);
            };
        };
        for (var k in shortcuts) {
            var shortcut = shortcuts[k];
            if (!shortcut || shortcut === '') {
                continue;
            }
            if (shortcut === 'DevTools') {
                this.shortcuts[k] = function () { return browser_window.toggleDevTools(); };
                continue;
            }
            if (shortcut === 'QuitApp') {
                this.shortcuts[k] = function () { return browser_window.close(); };
                continue;
            }
            this.shortcuts[k] = key_receiver_for(shortcut);
        }
        browser_window.on('blur', function () {
            _this.unregisterAll();
        });
        browser_window.on('focus', function () {
            _this.registerAll();
        });
    }
    KeyShortcuts.prototype.registerAll = function () {
        for (var key in this.shortcuts) {
            globalShortcut.register(key, this.shortcuts[key]);
        }
    };
    KeyShortcuts.prototype.unregisterAll = function () {
        globalShortcut.unregisterAll();
    };
    return KeyShortcuts;
})();
exports.default = KeyShortcuts;
