var FooBar;
(function (FooBar) {
    'use strict';
    var Receiver = (function () {
        function Receiver(shortcuts) {
            var _this = this;
            this.shortcuts = shortcuts;
            this.callbacks = {};
            var key_handler_for = function (action) { return function () { return _this.dispatch_shortcut(action); }; };
            for (var key in this.shortcuts) {
                Mousetrap.bind(key, key_handler_for(this.shortcuts[key]));
            }
        }
        Receiver.prototype.on = function (action, callback) {
            this.callbacks[action] = callback;
        };
        Receiver.prototype.dispatch_shortcut = function (action) {
            if (action in this.callbacks) {
                this.callbacks[action]();
            }
        };
        return Receiver;
    }());
    FooBar.Receiver = Receiver;
})(FooBar || (FooBar = {}));
//# sourceMappingURL=foo-bar.js.map