"use strict";
var fs = require('fs');
var path = require('path');
module.exports = function () {
    function defaultPath() {
        var cwd = process.cwd();
        if (process.platform === 'darwin' && cwd === '/') {
            var doc_dir = path.join(process.env.HOME, 'Documents');
            if (fs.existsSync(doc_dir)) {
                return doc_dir;
            }
            else {
                return path.join(process.resourcesPath, 'README.md');
            }
        }
        return cwd;
    }
    if (process.argv.length < 2) {
        return defaultPath();
    }
    var last_arg = process.argv[process.argv.length - 1];
    if (fs.existsSync(last_arg)) {
        return path.resolve(last_arg);
    }
    else {
        return defaultPath();
    }
};
//# sourceMappingURL=initial_path.js.map